#include "installer.h"
#include <unistd.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <fcntl.h>
#include "packages.h"

#define BLKGETSIZE 0x00001260

int again = 1;
int part1_main();
int grub_main(); 


/* main functions */
void pack_prev() {
	tgt_unlink(window);
	part1_main();
	tgt_refresh(window);
}

void own_prev() {
	tgt_unlink(window);
	pack_main();
	tgt_refresh(window);
}

void hotkeyspack(struct tgt_object *obj, char k) {
	int s,p;
	char *tmp;
	s = sppos[selectedpack].s;
	p = sppos[selectedpack].p;
	
	tmp = (char*)malloc(DEPMEM);
	if ( tmp == NULL) exit(1);
	
	sprintf(tmp,"Lers: %s\n\nFggsgek: %s\n",packages[s].description[p],packages[s].depends[p]);
	
	if (k == 's') { help(helpnum); 
	
	} else if (k == TGT_KEY_ESC) { off();
		
	} else if (k == 'i') {
	 
	 if (sorp[selectedpack] == 2) { 
	  tgt_easyrequest(window,packages[s].packname[p],tmp," Ok ");
	 } else if (sorp[selectedpack] == 1) {
	  tgt_easyrequest(window,packages[s].section,packages[s].sectionname," Ok ");
	 }
	
	}
}

/* csomagok feltoltese a Packages filebol */
void getpack() {
	FILE *f;
	char file[] = {"/Packages"}; 
	char tmp2[200], u[200];
	char packname[200], packver[100], packdesc[300], packinstsize[20], 
	packsect[20], packf[300];
	int i,j,x,y,s,z;
	char *tmp1, *tmp3, c; 
	char *packdeps;
	struct stat buf;
	
	packdeps = (char*)malloc(DEPMEM);
	if (packdeps == NULL) { exit(1);  }
		
	tmp1 = (char*)malloc(DEPMEM);
	if (tmp1 == NULL) { exit(1); }  
	
	tmp3 = (char*)malloc(DEPMEM);
	if (tmp3 == NULL) { exit(1); }  
			
	for (i = 0; i<SECTMAX; i++) {
	 for (j= 0; j<500; j++) { 
	  packages[i].depends[j] = (char*)malloc(DEPMEM);
	  if (packages[i].depends[j] == NULL) { exit(1); } 
	 }
	}
	
	for (i = 0; i<SECTMAX; i++) {
	 for (j= 0; j<500; j++) { 
	  packages[i].dependsplit[j] = (char*)malloc(DEPMEM);
	  if (packages[i].depends[j] == NULL) { exit(1); } 
	 }
	}
		
	sprintf(packages[0].section,"base");
	sprintf(packages[0].sectionname,"Alaprendszer");
	
	sprintf(packages[1].section,"libs");
	sprintf(packages[1].sectionname,"Kiegszt programok");
	
	sprintf(packages[2].section,"x11");
	sprintf(packages[2].sectionname,"Grafikus alkalmazsok");
	
	sprintf(packages[3].section,"console");
	sprintf(packages[3].sectionname,"Konzolos alkalmazsok");
		
	sprintf(packages[4].section,"gnome");
	sprintf(packages[4].sectionname,"GNOME grafikus fellet");
	
	sprintf(packages[5].section,"kde");
	sprintf(packages[5].sectionname,"KDE grafikus fellet");
	
	sprintf(packages[6].section,"lang");
	sprintf(packages[6].sectionname,"Programnyelvek");
	
	sprintf(packages[7].section,"perl");
	sprintf(packages[7].sectionname,"Perl");
	
	sprintf(packages[8].section,"python");
	sprintf(packages[8].sectionname,"Python");
	
	sprintf(packages[9].section,"devel");
	sprintf(packages[9].sectionname,"Fejleszti programok");
	
	sprintf(packages[10].section,"dev");
	sprintf(packages[10].sectionname,"Fejleszti csomagok");
	
	sprintf(packages[11].section,"daemons");
	sprintf(packages[11].sectionname,"Szerver programok");
	
	sprintf(packages[12].section,"games");
	sprintf(packages[12].sectionname,"Jtkok");
	
	sprintf(packages[13].section,"docs");
	sprintf(packages[13].sectionname,"Dokumentcik");
	
	/* nullazas */
	j = 0;
	for (i = 0; i<SECTMAX; i++) { packages[i].sectnum = 0; sectopen[i] = 0; }
	
	if ( (stat("/Packages",&buf) == -1) ) { sprintf(file,"/packages/Packages"); }			
	
		
    if ( (f = fopen(file,"r")) ) {
	 	 
	  	while ( (fgets(tmp1,DEPMEM,f)) != NULL) {
			
			if ( (strstr(tmp1,"Package:")) ) {
	     	 sscanf(tmp1,"%s %s",tmp2,packname); 
	    		
			 	while (1) {
		 		 fgets(tmp1,DEPMEM,f);
		 		 
				 if ( (strstr(tmp1,"Version:")) ) {
	      		  sscanf(tmp1,"%s %s",tmp2,packver); 
		 		 }
				 
				 if ( (strstr(tmp1,"Section:")) ) {
	      		  sscanf(tmp1,"%s %s",tmp2,packsect); 
				  if ( !(strcmp(packsect,"lang/perl")) ) { sprintf(packsect,"perl"); }
				  if ( !(strcmp(packsect,"lang/python")) ) { sprintf(packsect,"python"); }				  
		 		 }
				 
				 if ( (strstr(tmp1,"Depends:")) ) {
				  sscanf(tmp1,"%s %[^\n]",tmp2,packdeps); 
		 		 }
				 
				 if ( (strstr(tmp1,"Installed-Size:")) ) {
	      		  sscanf(tmp1,"%s %s",tmp2,packinstsize); 
		 		 }
				 
				 if ( (strstr(tmp1,"Description:")) ) {
	      		  sscanf(tmp1,"%s %[^\n]",tmp2,packdesc); 
		 		 }
				 
				 sprintf(packf,"%s_%s_i386.uhu",packname,packver);
				 
				 if ( !(strcmp(tmp1,"\n")) ) { break; }		 
				}
			}
			
			for (i = 0; i<17; i++) {
			 
			 if ( !(strcmp(packsect,packages[i].section)) ) {
			  
			  j = packages[i].sectnum;  
			  		  
			  sprintf(packages[i].packname[j],packname);
			  sprintf(packages[i].packversion[j],packver);
			  sprintf(packages[i].depends[j],packdeps);
			  sprintf(packages[i].description[j],packdesc); 
			  sprintf(packages[i].filename[j],packf);
			  packages[i].installedsize[j] = atoi(packinstsize);
			  packages[i].packinstall[j] = 0;
			  
/* ------------------- Depends szetvalasztasa ----------------------------*/
			  	y = strlen(packdeps);
				y++; packdeps[y] = '\0';
				s = z = 0;
							
				for (x = 0; x<y; x++) { 
				 c = packdeps[x];

				 if ( c != '\0' && c != ','  ) { 
				 
				  tmp3[s] = c; s++;				  

				 } else { tmp3[s] = '\0'; 
				 
				  if ( (strchr(tmp3,'(')) ) { sscanf(tmp3,"%s %s",tmp2,u);
				  } else { sscanf(tmp3,"%s",tmp2); }
				   
				  strcat(packages[i].dependsplit[j],tmp2);
				  tmp3[0] = '\0'; s = 0; 
				  strcat(packages[i].dependsplit[j],":"); 
				  
				 } 
				}  
								
/* -----------------------------------------------------------------------*/
		  
			  packages[i].sectnum++;			  
			 }
			}
	  }
	  	    	    	  
	  free(tmp1); free(packdeps);
	   	   	 
	} else { fprintf(stderr,"Hiba: Nem tudtam megnyitni a Packages filet!\n"); exit(1); }	
	
	
}

/* step_pack ablak kitoltese */
void pmax() {
	int i, sectminus;
	
	packmax = 0;
	sectminus = 0;
	
	 for (i =0; i<SECTMAX; i++) {
	  if (sectopen[i] == 1) { packmax = packmax+packages[i].sectnum; }
	  if ( packages[i].sectnum == 0 ) { sectminus++; }
	 }
	 packmax = packmax + SECTMAX - sectminus;
}

int listfill_pack(void **d, int c, int n, char *tmp, int k, int a) {
	int i,j, rownum = 0;
	char prows[PACKSUM][200];
	
	if(c == TGT_LISTREQ_GETMAX) {
	
	 return(packmax);	
	 
	} else { 
		
	 for (i = 0; i<SECTMAX; i++) {
	  
	  if ( packages[i].sectnum != 0 ) {
	  sprintf(prows[rownum],"<%s>",packages[i].sectionname); 
	  sorp[rownum] = 1; sppos[rownum].s = i; rownum++;
	   
	  if ( (sectopen[i]) == 1 ) {
	    
	   for (j = 0; j<packages[i].sectnum; j++) {
	     
	    if (packages[i].packinstall[j] == 1) {
		  sprintf(prows[rownum],"\t\t\t\t[x] %s_%s",packages[i].packname[j],packages[i].packversion[j]); 
		 } else {
		  sprintf(prows[rownum],"\t\t\t\t[ ] %s_%s",packages[i].packname[j],packages[i].packversion[j]); 
		 } 
		 
		 sorp[rownum] = 2; sppos[rownum].s = i; sppos[rownum].p = j; rownum++;		 
	    
		}	   
	   }	   
	 
	  }
	 }
	 
	 snprintf(tmp,k,prows[n],prows[rownum]);  
	 	 
	 if ( a == 1 ) { selectedpack = n; }	 	 	 	  
   }  	
   return(1); 
} 

void listdo_pack() {
	int s,p;
	s = sppos[selectedpack].s;
	p = sppos[selectedpack].p;
	
	if ( sorp[selectedpack] == 1) {
	 
	 if ( sectopen[s] == 0) { 
	  sectopen[s] = 1;
	 } else { sectopen[s] = 0; } 
	
	} else if ( sorp[selectedpack] == 2) {
	 
	 if (packages[s].packinstall[p] == 0) { packages[s].packinstall[p] = 1;	  
	 } else { packages[s].packinstall[p] = 0; }
	 
	}	
	
	pmax();
	tgt_refresh(list_pack);
}

/* adatok elmentese */
void depcheck(int s, int p) {
		char *tmp1, tmp2[120];
		int i,j;
		
		/* nullazas */
		again = 0;
		
		tmp1 = strtok(packages[s].dependsplit[p],":");
		
		for (i = 0; i<SECTMAX; i++) {
		 for (j = 0; j<packages[i].sectnum; j++) {
		  
		  if ( !(strcmp(tmp1,packages[i].packname[j])) ) {
		   
		   if (packages[i].packinstall[j] != 1) {
		    packages[i].packinstall[j] = 1; again = 1;
		   } 
		  } 		   
		 }
		}
		
		while (tmp1 != NULL) {
		 tmp1 = strtok(NULL,":");
		 if (tmp1 == NULL) { break; } 
			
		 for (i = 0; i<SECTMAX; i++) {
		 for (j = 0; j<packages[i].sectnum; j++) {
		  
		  if ( !(strcmp(tmp1,packages[i].packname[j])) ) {
		   
		   if (packages[i].packinstall[j] != 1) {
		    packages[i].packinstall[j] = 1; again = 1;
		   }  
		  }  
		 }
		} 
		
		} /* while end */
		
}

void savepack() {
	int i,j, ksize, c;
	FILE *f;
	char packfile[200];
	char *use, tmp[200], tmp2[200];
	conf = tgt_load_conf(confile);
	use = tgt_get_conf(conf,"packs","packfile","default");
	
	
	/* base hozzadasa */
	if ( !(f = fopen("/usr/share/uhu-console-installer/base","r")) ) { popupmsg("Hiba","Nem tudtam megnyitni a base filet!\n\n"); off(); }
	else {
		
		while ( (fgets(tmp,sizeof(tmp),f)) != NULL ) {
		 
		ksize = strlen(tmp) - 1;
		for (c = 0; c<ksize; c++) { tmp2[c] = tmp[c]; } tmp2[c] = '\0';	
				
		 for (i = 0; i<SECTMAX; i++) {
	   	  for (j=0; j<packages[i].sectnum; j++) {
	       if ( !(strcmp(packages[i].packname[j],tmp2)) ) { packages[i].packinstall[j] = 1; }
		   
	      }
	     }
	 
		} fclose(f);
   }	
	
   /* fuggoseg ellenorzes */
	while (1) {
	 if (again == 0) { break; }
	 for (i = 0; i<SECTMAX; i++) {
	  for (j = 0; j<packages[i].sectnum; j++) {
	   if (packages[i].packinstall[j] == 1) { depcheck(i,j); }
	  }
	 }	
	}
	
	/* packfileba elmentes */ 
	if ( !(strcmp(use,"default")) ) {
		sprintf(packfile,"/tmp/uhu-packages.conf");
		tgt_set_conf(conf,"packs","packfile",packfile);
		tgt_save_conf(conf,confile);
	} else {
	 sprintf(packfile,"%s",use);
	}		
	
	if ( !(f = fopen(packfile,"w")) ) { popupmsg("Hiba","Nem tudtam megnyitni az uhu-packages.conf filet!\n\n"); off(); }
	else {
	
	 for (i = 0; i<SECTMAX; i++) {
	  for (j=0; j<packages[i].sectnum; j++) {
	   if (packages[i].packinstall[j] == 1) {
			fprintf(f,"%s\n",packages[i].filename[j]);	   
       }
	  }  
	 }
	
	} fclose(f);
		
	tgt_unlink(window);
	grub_main();
	tgt_refresh(window); 		
}

void fullinst() {
	int i,j;
	
	for(i = 0; i<SECTMAX; i++) {
	 for (j = 0; j<packages[i].sectnum; j++) {
	  
	 if ( firewall_edition == 1 && (strstr(packages[i].filename[j],"-dev_")) || server_edition == 1 && (strstr(packages[i].filename[j],"-dev_"))) { 
	 	packages[i].packinstall[j] = 0; 
				
	 } else {  packages[i].packinstall[j] = 1;  } 
	 
	 }	
	}
	hddcheck();	
}


int hddcheck() {		/* eleg e a hely a telepiteshez */
	char *use, tmp[300], p3dev[300], null[1000], *ts1, *ts2;
	int fd,a;
	int size,i,tmpsize = 0, j,k, packs_size = 0;
	
	conf = tgt_load_conf(confile);
	use = tgt_get_conf(conf,"part2","disc","default");
	
	if ( (strcmp(use,"default")) ) {
	
		if ( (fd = open(use,O_RDONLY | O_NONBLOCK)) ) {
		 if( (a = ioctl(fd,BLKGETSIZE, &size)) == 0) {
		  size = size / 2; 
		 }			
		} close(fd);
	
	} else { 
	
	 use = tgt_get_conf(conf,"part3","root","default");
	
	 if ( (strcmp(use,"default")) ) {
	 
	 	sscanf(use,"%[^,],%s",p3dev,null);
	
		if ( (fd = open(p3dev,O_RDONLY | O_NONBLOCK)) ) {
		 if( (a = ioctl(fd,BLKGETSIZE, &size)) == 0) {
		   size = size / 2;
		 }			
		} close(fd);
	
	 }
	 
	 i = 1;	
	 while (1) {
	 	
	 	sprintf(tmp,"part%d",i);
		use = tgt_get_conf(conf,"part3",tmp,"default");
		
		if ( !(strcmp(use,"default")) ) { break; } 
		
		sscanf(use,"%[^,],%s",p3dev,null);
		
		if ( (fd = open(p3dev,O_RDONLY | O_NONBLOCK)) ) {
		 if( (a = ioctl(fd,BLKGETSIZE, &tmpsize)) == 0) {
		   size = size + (tmpsize / 2);
		 }			
		} close(fd);
		
		i++;
	 }
	
	
	}
	
	
	for (j = 0; j<SECTMAX; j++) {
	 for (k = 0; k<packages[j].sectnum; k++) {
	 
	  if ( packages[j].packinstall[k] == 1 ) {
	  	packs_size = packs_size + packages[j].installedsize[k];
	  }
	  
	 }
	}
	
	
	if ( packs_size < size ) { 
	 savepack(); 
	} else {
	 
	 ts1 = size_value(size);
	 ts2 = size_value(packs_size);
	 
	 sprintf(tmp,"A rendelkezsre ll hely kevesebb, mint a telepteni kvnt csomagok sszmrete!\n\nrendelkezsre ll hely: %s\ncsomagok mrete: %s",ts1,ts2);	
	 popupmsg("Hiba",tmp);
	}

}

void step_pack() {
	
	window = tgt_createobject(
	TGT_CLASS_WINDOW, (tgtt[]) {
	TGTT_WINDOW_TITLE, (tgtt) "UHU-Linux - Csomagkivlaszts",
	TGTT_WINDOW_TITLECOLOR,3,
	TGTT_WINDOW_BORDERCOLOR,3,
	TGTT_CALLBACK, (tgtt) hotkeyspack,
	TGTT_XS, 78, TGTT_YS, 23,	
	TGTT_END,0 
	});
	
	tgt_set(window, TGTT_X, (tgt_getterminal()->x_size - 78) / 2);
	tgt_set(window, TGTT_Y, (tgt_getterminal()->y_size - 23) / 2);	
	
	tgt_link(window,desktop);
	
	list_pack = tgt_createandlink(window,TGT_CLASS_LIST,(tgtt[]) {
	TGTT_X,2,TGTT_Y,2,
	TGTT_XS,74,TGTT_YS,14,
	TGTT_LIST_ACTIVEBG,1,
	TGTT_LIST_FRAMECOLOR,3,
	TGTT_ID,1000,
	TGTT_LIST_DATACALLBACK, (tgtt) listfill_pack, 
	TGTT_CALLBACK,(tgtt) listdo_pack,
	TGTT_END,0
	});
	
	text_pack = tgt_createandlink(window,TGT_CLASS_LABEL,(tgtt[]) {
	TGTT_X,3,TGTT_Y,17,
	TGTT_FG,6,
	TGTT_LABEL_TEXT,(tgtt) "A `i` bet lenyomsval tudsz informcit krni a kivlasztott csomagrl.",
	TGTT_END,0});

	line_pack = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,1,TGTT_Y,20,
	TGTT_LABEL_TEXT, (tgtt) "----------------------------------------------------------------------------",	
	TGTT_END,0});

		
	b1_pack = tgt_createandlink(window,TGT_CLASS_BUTTON,(tgtt[]) {
	TGTT_X,16,TGTT_Y, 21,
	TGTT_BUTTON_CAPTION, (tgtt) " Vissza ",
	TGTT_CALLBACK, (tgtt) own_prev, 
	TGTT_BG,1,
	TGTT_END });
	
	b2_pack = tgt_createandlink(window,TGT_CLASS_BUTTON,(tgtt[]) {
	TGTT_X,58,TGTT_Y,21,
	TGTT_BUTTON_CAPTION, (tgtt) "  Ok  ",
	TGTT_CALLBACK, (tgtt) hddcheck, 
	TGTT_BG,1,
	TGTT_END });
	
}

/* valaszto ablak */
void custominst() {
	tgt_unlink(window);
	tgt_destroyobject(window);
	step_pack();
	tgt_refresh(window);
}

void step_prepack() {
	struct tgt_object *b1pre, *b2pre, *b3pre, *linepre;

	window = tgt_createobject(
	TGT_CLASS_WINDOW, (tgtt[]) {
	TGTT_WINDOW_TITLE, (tgtt) "UHU LINUX - Csomagkivlaszts",
	TGTT_WINDOW_TITLECOLOR,3,
	TGTT_WINDOW_BORDERCOLOR,3,
	TGTT_CALLBACK, (tgtt) hotkeyspack,
	TGTT_XS, 78, TGTT_YS, 23,	
	TGTT_END,0 
	});
	
	tgt_set(window, TGTT_X, (tgt_getterminal()->x_size - 78) / 2);
	tgt_set(window, TGTT_Y, (tgt_getterminal()->y_size - 23) / 2);	
	
	tgt_link(window,desktop);
	
	tgt_createandlink(window,TGT_CLASS_LABEL,(tgtt[]) {
	TGTT_X,2,TGTT_Y,2,
	TGTT_LABEL_TEXT, (tgtt) "Vlaszd ki, hogyan szeretnl telepteni.",	
	TGTT_FG,6,
	TGTT_END,0});
	
	b2pre = tgt_createandlink(window,TGT_CLASS_BUTTON,(tgtt[]) {
	TGTT_X,28,TGTT_Y,10,
	TGTT_BUTTON_CAPTION, (tgtt) "  Teljes telepts  ",
	TGTT_CALLBACK, (tgtt) fullinst, 
	TGTT_BG,1,
	TGTT_END });
	
	b3pre = tgt_createandlink(window,TGT_CLASS_BUTTON,(tgtt[]) {
	TGTT_X,24,TGTT_Y,12,
	TGTT_BUTTON_CAPTION, (tgtt) "  Egyni csomagkivlaszts  ",
	TGTT_CALLBACK, (tgtt) custominst, 
	TGTT_BG,1,
	TGTT_END });
	
	linepre = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,1,TGTT_Y,20,
	TGTT_LABEL_TEXT, (tgtt) "----------------------------------------------------------------------------",	
	TGTT_END,0});

		
	b1pre = tgt_createandlink(window,TGT_CLASS_BUTTON,(tgtt[]) {
	TGTT_X,16,TGTT_Y,21,
	TGTT_BUTTON_CAPTION, (tgtt) " Vissza ",
	TGTT_CALLBACK, (tgtt) pack_prev, 
	TGTT_BG,1,
	TGTT_END });

}

/* main */
int pack_main () {
		
	helpnum = 6;
			
    getpack();
	pmax();
		
 	step_prepack();
	
	return(0);
}
